#line 1 "C:/Program Files/Mikroelektronika/Package Manager/Examples/Building Blocks/RS232CMD/UART.c"
#line 1 "c:/program files/mikroelektronika/package manager/examples/building blocks/rs232cmd/uart.h"
#line 5 "c:/program files/mikroelektronika/package manager/examples/building blocks/rs232cmd/uart.h"
extern unsigned char rxBuf[];
extern char rx_packet;
extern char rx_ptr;

extern void rs232_init(void);
extern void PrintHandler(char);
extern void decode_rs232(void);
#line 61 "C:/Program Files/Mikroelektronika/Package Manager/Examples/Building Blocks/RS232CMD/UART.c"
enum cmds
{
 MOD=1,
 DAC,
 ADC,
 SET
};
#line 74 "C:/Program Files/Mikroelektronika/Package Manager/Examples/Building Blocks/RS232CMD/UART.c"
volatile unsigned char rxBuf[ 16 ];
volatile char rxptr = 0;
volatile char rx_lastcmd;
volatile char rx_packet;
volatile char rx_ptr;
volatile char cmd;
int iTemp;
char cTemp;
volatile char cmpChar;
char getset = 0;
unsigned short cmd_addr;
unsigned long iLong;
float fTemp;
volatile char chan;


char model[10]="MikroXYZ\r";
float adcvalue = 1.234;
int dacvalue = 0;




void clear_rx(void);
char check_rx(void);
void rs232_init(void);
void PrintHandler(char);
void rx_interrupt(void);





char check_rx(void)
{
 char loop;
 char res = 0;
 res = 0;


 for(loop=0;loop< 16 ;loop++)
 {
 if(rxBuf[loop]==13 || rxBuf[loop]==10)
 {
 res = 1;
 asm nop;
 }
 }
 return res;
}

void clear_rx(void)
{
 rx_packet = 0;
 rx_ptr = 0;
 memset(rxBuf,'\0',strlen(rxBuf));
 asm nop;
}
#line 144 "C:/Program Files/Mikroelektronika/Package Manager/Examples/Building Blocks/RS232CMD/UART.c"
void PrintHandler(char c)
{
 UART1_Write(c);
}

void rs232_init(void)
{
 clear_rx();
 rx_packet = 0;
 rx_ptr = 0;
 UART1_Init(9600);
 asm nop;
}
#line 164 "C:/Program Files/Mikroelektronika/Package Manager/Examples/Building Blocks/RS232CMD/UART.c"
char my_cmd(void)
{
 char cm[3];


 cm[0]=toupper(rxBuf[0]);
 cm[1]=toupper(rxBuf[1]);
 cm[2]=toupper(rxBuf[2]);
 asm nop;
#line 178 "C:/Program Files/Mikroelektronika/Package Manager/Examples/Building Blocks/RS232CMD/UART.c"
 cmpChar = strncmp("MOD",&cm[0],3);
 asm nop;
 if(cmpChar==0)
 {
 asm nop;
 return MOD;
 }

 cmpChar = strncmp("DAC",&cm[0],3);
 asm nop;
 if(cmpChar==0)
 {
 asm nop;
 return DAC;
 }

 cmpChar = strncmp("ADC",&cm[0],3);
 asm nop;
 if(cmpChar==0)
 {
 asm nop;
 return ADC;
 }


 cmpChar = strncmp("SET",&cm[0],3);
 asm nop;
 if(cmpChar==0)
 {
 asm nop;
 return SET;
 }


 asm nop;
 return 0;
}
#line 220 "C:/Program Files/Mikroelektronika/Package Manager/Examples/Building Blocks/RS232CMD/UART.c"
void decode_rs232(void)
{
 cmd = my_cmd();
 asm nop;
 asm nop;
 getset = rxBuf[ 3 ];
 asm nop;
 asm nop;
#line 231 "C:/Program Files/Mikroelektronika/Package Manager/Examples/Building Blocks/RS232CMD/UART.c"
 switch(cmd)
 {
 case MOD:
 if(getset=='?')
 {
 UART_Write_Text(&model);
 asm nop;
 }
 else if(getset=='>')
 {

 asm nop;
 }
 break;

 case DAC:
 if(getset=='?')
 {
 dacvalue;
 PrintOut(PrintHandler, "%u\r",dacvalue);
 asm nop;
 }
 else if(getset=='>')
 {
 iTemp = atoi(&rxBuf[ 4 ]);
 dacvalue = iTemp;
 asm nop;
 }
 break;

 case ADC:
 if(getset=='?')
 {

 PrintOut(PrintHandler, "%5.0f\r",adcvalue);
 asm nop;
 }
 else if(getset=='>')
 {

 }
 asm nop;
 break;

 case SET:
 if(getset=='?')
 {
 cTemp = PORTB;
 iTemp = cTemp;
 PrintOut(PrintHandler, "%X\r",iTemp);
 asm nop;
 }
 else if(getset=='>')
 {
 iTemp = atoi(&rxBuf[ 4 ]);
 cTemp = iTemp & 0xFF;
 PORTB = cTemp;
 asm nop;
 }
 asm nop;
 break;


 default:
 UART1_Write_Text("FAIL\r");
 asm nop;
 break;
 }
 clear_rx();
}
