
_check_rx:

;UART.c,107 :: 		char check_rx(void)
;UART.c,110 :: 		char res = 0;
	CLRF        check_rx_res_L0+0 
;UART.c,111 :: 		res = 0;
	CLRF        check_rx_res_L0+0 
;UART.c,114 :: 		for(loop=0;loop<RX_BUF_LEN;loop++)
	CLRF        R2 
L_check_rx0:
	MOVLW       16
	SUBWF       R2, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_check_rx1
;UART.c,116 :: 		if(rxBuf[loop]==13 || rxBuf[loop]==10)
	MOVLW       _rxBuf+0
	MOVWF       FSR0L 
	MOVLW       hi_addr(_rxBuf+0)
	MOVWF       FSR0H 
	MOVF        R2, 0 
	ADDWF       FSR0L, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0H, 1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	XORLW       13
	BTFSC       STATUS+0, 2 
	GOTO        L__check_rx29
	MOVLW       _rxBuf+0
	MOVWF       FSR0L 
	MOVLW       hi_addr(_rxBuf+0)
	MOVWF       FSR0H 
	MOVF        R2, 0 
	ADDWF       FSR0L, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0H, 1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	XORLW       10
	BTFSC       STATUS+0, 2 
	GOTO        L__check_rx29
	GOTO        L_check_rx5
L__check_rx29:
;UART.c,118 :: 		res = 1;
	MOVLW       1
	MOVWF       check_rx_res_L0+0 
;UART.c,119 :: 		asm nop;
	NOP
;UART.c,120 :: 		}
L_check_rx5:
;UART.c,114 :: 		for(loop=0;loop<RX_BUF_LEN;loop++)
	INCF        R2, 1 
;UART.c,121 :: 		}
	GOTO        L_check_rx0
L_check_rx1:
;UART.c,122 :: 		return res;
	MOVF        check_rx_res_L0+0, 0 
	MOVWF       R0 
;UART.c,123 :: 		}
L_end_check_rx:
	RETURN      0
; end of _check_rx

_clear_rx:

;UART.c,125 :: 		void clear_rx(void)
;UART.c,127 :: 		rx_packet = 0;
	CLRF        _rx_packet+0 
;UART.c,128 :: 		rx_ptr = 0;
	CLRF        _rx_ptr+0 
;UART.c,129 :: 		memset(rxBuf,'\0',strlen(rxBuf));
	MOVLW       _rxBuf+0
	MOVWF       FARG_strlen_s+0 
	MOVLW       hi_addr(_rxBuf+0)
	MOVWF       FARG_strlen_s+1 
	CALL        _strlen+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_memset_n+0 
	MOVF        R1, 0 
	MOVWF       FARG_memset_n+1 
	MOVLW       _rxBuf+0
	MOVWF       FARG_memset_p1+0 
	MOVLW       hi_addr(_rxBuf+0)
	MOVWF       FARG_memset_p1+1 
	CLRF        FARG_memset_character+0 
	CALL        _memset+0, 0
;UART.c,130 :: 		asm nop;
	NOP
;UART.c,131 :: 		}
L_end_clear_rx:
	RETURN      0
; end of _clear_rx

_PrintHandler:

;UART.c,144 :: 		void PrintHandler(char c)
;UART.c,146 :: 		UART1_Write(c);
	MOVF        FARG_PrintHandler_c+0, 0 
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;UART.c,147 :: 		}
L_end_PrintHandler:
	RETURN      0
; end of _PrintHandler

_rs232_init:

;UART.c,149 :: 		void rs232_init(void)
;UART.c,151 :: 		clear_rx();
	CALL        _clear_rx+0, 0
;UART.c,152 :: 		rx_packet = 0;
	CLRF        _rx_packet+0 
;UART.c,153 :: 		rx_ptr = 0;
	CLRF        _rx_ptr+0 
;UART.c,154 :: 		UART1_Init(9600);       // init UART
	MOVLW       64
	MOVWF       SPBRG+0 
	BCF         TXSTA+0, 2, 0
	CALL        _UART1_Init+0, 0
;UART.c,155 :: 		asm nop;
	NOP
;UART.c,156 :: 		}
L_end_rs232_init:
	RETURN      0
; end of _rs232_init

_my_cmd:

;UART.c,164 :: 		char my_cmd(void)
;UART.c,169 :: 		cm[0]=toupper(rxBuf[0]);
	MOVF        _rxBuf+0, 0 
	MOVWF       FARG_toupper_character+0 
	CALL        _toupper+0, 0
	MOVF        R0, 0 
	MOVWF       my_cmd_cm_L0+0 
;UART.c,170 :: 		cm[1]=toupper(rxBuf[1]);
	MOVF        _rxBuf+1, 0 
	MOVWF       FARG_toupper_character+0 
	CALL        _toupper+0, 0
	MOVF        R0, 0 
	MOVWF       my_cmd_cm_L0+1 
;UART.c,171 :: 		cm[2]=toupper(rxBuf[2]);
	MOVF        _rxBuf+2, 0 
	MOVWF       FARG_toupper_character+0 
	CALL        _toupper+0, 0
	MOVF        R0, 0 
	MOVWF       my_cmd_cm_L0+2 
;UART.c,172 :: 		asm nop;
	NOP
;UART.c,178 :: 		cmpChar = strncmp("MOD",&cm[0],3);
	MOVLW       ?lstr1_UART+0
	MOVWF       FARG_strncmp_s1+0 
	MOVLW       hi_addr(?lstr1_UART+0)
	MOVWF       FARG_strncmp_s1+1 
	MOVLW       my_cmd_cm_L0+0
	MOVWF       FARG_strncmp_s2+0 
	MOVLW       hi_addr(my_cmd_cm_L0+0)
	MOVWF       FARG_strncmp_s2+1 
	MOVLW       3
	MOVWF       FARG_strncmp_len+0 
	CALL        _strncmp+0, 0
	MOVF        R0, 0 
	MOVWF       _cmpChar+0 
;UART.c,179 :: 		asm nop;
	NOP
;UART.c,180 :: 		if(cmpChar==0)
	MOVF        _cmpChar+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_my_cmd6
;UART.c,182 :: 		asm nop;
	NOP
;UART.c,183 :: 		return MOD;
	MOVLW       1
	MOVWF       R0 
	GOTO        L_end_my_cmd
;UART.c,184 :: 		}
L_my_cmd6:
;UART.c,186 :: 		cmpChar = strncmp("DAC",&cm[0],3);
	MOVLW       ?lstr2_UART+0
	MOVWF       FARG_strncmp_s1+0 
	MOVLW       hi_addr(?lstr2_UART+0)
	MOVWF       FARG_strncmp_s1+1 
	MOVLW       my_cmd_cm_L0+0
	MOVWF       FARG_strncmp_s2+0 
	MOVLW       hi_addr(my_cmd_cm_L0+0)
	MOVWF       FARG_strncmp_s2+1 
	MOVLW       3
	MOVWF       FARG_strncmp_len+0 
	CALL        _strncmp+0, 0
	MOVF        R0, 0 
	MOVWF       _cmpChar+0 
;UART.c,187 :: 		asm nop;
	NOP
;UART.c,188 :: 		if(cmpChar==0)
	MOVF        _cmpChar+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_my_cmd7
;UART.c,190 :: 		asm nop;
	NOP
;UART.c,191 :: 		return DAC;
	MOVLW       2
	MOVWF       R0 
	GOTO        L_end_my_cmd
;UART.c,192 :: 		}
L_my_cmd7:
;UART.c,194 :: 		cmpChar = strncmp("ADC",&cm[0],3);
	MOVLW       ?lstr3_UART+0
	MOVWF       FARG_strncmp_s1+0 
	MOVLW       hi_addr(?lstr3_UART+0)
	MOVWF       FARG_strncmp_s1+1 
	MOVLW       my_cmd_cm_L0+0
	MOVWF       FARG_strncmp_s2+0 
	MOVLW       hi_addr(my_cmd_cm_L0+0)
	MOVWF       FARG_strncmp_s2+1 
	MOVLW       3
	MOVWF       FARG_strncmp_len+0 
	CALL        _strncmp+0, 0
	MOVF        R0, 0 
	MOVWF       _cmpChar+0 
;UART.c,195 :: 		asm nop;
	NOP
;UART.c,196 :: 		if(cmpChar==0)
	MOVF        _cmpChar+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_my_cmd8
;UART.c,198 :: 		asm nop;
	NOP
;UART.c,199 :: 		return ADC;
	MOVLW       3
	MOVWF       R0 
	GOTO        L_end_my_cmd
;UART.c,200 :: 		}
L_my_cmd8:
;UART.c,203 :: 		cmpChar = strncmp("SET",&cm[0],3);
	MOVLW       ?lstr4_UART+0
	MOVWF       FARG_strncmp_s1+0 
	MOVLW       hi_addr(?lstr4_UART+0)
	MOVWF       FARG_strncmp_s1+1 
	MOVLW       my_cmd_cm_L0+0
	MOVWF       FARG_strncmp_s2+0 
	MOVLW       hi_addr(my_cmd_cm_L0+0)
	MOVWF       FARG_strncmp_s2+1 
	MOVLW       3
	MOVWF       FARG_strncmp_len+0 
	CALL        _strncmp+0, 0
	MOVF        R0, 0 
	MOVWF       _cmpChar+0 
;UART.c,204 :: 		asm nop;
	NOP
;UART.c,205 :: 		if(cmpChar==0)
	MOVF        _cmpChar+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_my_cmd9
;UART.c,207 :: 		asm nop;
	NOP
;UART.c,208 :: 		return SET;
	MOVLW       4
	MOVWF       R0 
	GOTO        L_end_my_cmd
;UART.c,209 :: 		}
L_my_cmd9:
;UART.c,212 :: 		asm nop;
	NOP
;UART.c,213 :: 		return 0;    // invalid (thats why ENUMS start at 1!!)
	CLRF        R0 
;UART.c,214 :: 		}
L_end_my_cmd:
	RETURN      0
; end of _my_cmd

_decode_rs232:

;UART.c,220 :: 		void decode_rs232(void)
;UART.c,222 :: 		cmd =  my_cmd();   // get cmd & set channel
	CALL        _my_cmd+0, 0
	MOVF        R0, 0 
	MOVWF       _cmd+0 
;UART.c,223 :: 		asm nop;
	NOP
;UART.c,224 :: 		asm nop;
	NOP
;UART.c,225 :: 		getset = rxBuf[RS_GETSET];          // get or set
	MOVF        _rxBuf+3, 0 
	MOVWF       _getset+0 
;UART.c,226 :: 		asm nop;
	NOP
;UART.c,227 :: 		asm nop;
	NOP
;UART.c,231 :: 		switch(cmd)         // switch cmd
	GOTO        L_decode_rs23210
;UART.c,233 :: 		case MOD:     // model #
L_decode_rs23212:
;UART.c,234 :: 		if(getset=='?') // get value
	MOVF        _getset+0, 0 
	XORLW       63
	BTFSS       STATUS+0, 2 
	GOTO        L_decode_rs23213
;UART.c,236 :: 		UART_Write_Text(&model);          // write out data
	MOVLW       _model+0
	MOVWF       FARG_UART_Write_Text_uart_text+0 
	MOVLW       hi_addr(_model+0)
	MOVWF       FARG_UART_Write_Text_uart_text+1 
	CALL        _UART_Write_Text+0, 0
;UART.c,237 :: 		asm nop;
	NOP
;UART.c,238 :: 		}
	GOTO        L_decode_rs23214
L_decode_rs23213:
;UART.c,239 :: 		else if(getset=='>')       // set
	MOVF        _getset+0, 0 
	XORLW       62
	BTFSS       STATUS+0, 2 
	GOTO        L_decode_rs23215
;UART.c,242 :: 		asm nop;
	NOP
;UART.c,243 :: 		}
L_decode_rs23215:
L_decode_rs23214:
;UART.c,244 :: 		break;
	GOTO        L_decode_rs23211
;UART.c,246 :: 		case DAC:    // DAC value
L_decode_rs23216:
;UART.c,247 :: 		if(getset=='?') // get
	MOVF        _getset+0, 0 
	XORLW       63
	BTFSS       STATUS+0, 2 
	GOTO        L_decode_rs23217
;UART.c,250 :: 		PrintOut(PrintHandler, "%u\r",dacvalue);
	MOVLW       _PrintHandler+0
	MOVWF       FARG_PrintOut_prntoutfunc+0 
	MOVLW       hi_addr(_PrintHandler+0)
	MOVWF       FARG_PrintOut_prntoutfunc+1 
	MOVLW       FARG_PrintHandler_c+0
	MOVWF       FARG_PrintOut_prntoutfunc+2 
	MOVLW       hi_addr(FARG_PrintHandler_c+0)
	MOVWF       FARG_PrintOut_prntoutfunc+3 
	MOVLW       ?lstr_5_UART+0
	MOVWF       FARG_PrintOut_f+0 
	MOVLW       hi_addr(?lstr_5_UART+0)
	MOVWF       FARG_PrintOut_f+1 
	MOVLW       higher_addr(?lstr_5_UART+0)
	MOVWF       FARG_PrintOut_f+2 
	MOVF        _dacvalue+0, 0 
	MOVWF       FARG_PrintOut_prntoutfunc+7 
	MOVF        _dacvalue+1, 0 
	MOVWF       FARG_PrintOut_prntoutfunc+8 
	CALL        _PrintOut+0, 0
;UART.c,251 :: 		asm nop;
	NOP
;UART.c,252 :: 		}
	GOTO        L_decode_rs23218
L_decode_rs23217:
;UART.c,253 :: 		else if(getset=='>')       // set
	MOVF        _getset+0, 0 
	XORLW       62
	BTFSS       STATUS+0, 2 
	GOTO        L_decode_rs23219
;UART.c,255 :: 		iTemp = atoi(&rxBuf[RS_DATA]);     // get value
	MOVLW       _rxBuf+4
	MOVWF       FARG_atoi_s+0 
	MOVLW       hi_addr(_rxBuf+4)
	MOVWF       FARG_atoi_s+1 
	CALL        _atoi+0, 0
	MOVF        R0, 0 
	MOVWF       _iTemp+0 
	MOVF        R1, 0 
	MOVWF       _iTemp+1 
;UART.c,256 :: 		dacvalue = iTemp;                  // assign
	MOVF        R0, 0 
	MOVWF       _dacvalue+0 
	MOVF        R1, 0 
	MOVWF       _dacvalue+1 
;UART.c,257 :: 		asm nop;
	NOP
;UART.c,258 :: 		}
L_decode_rs23219:
L_decode_rs23218:
;UART.c,259 :: 		break;
	GOTO        L_decode_rs23211
;UART.c,261 :: 		case ADC:    // get ADC value
L_decode_rs23220:
;UART.c,262 :: 		if(getset=='?') // get
	MOVF        _getset+0, 0 
	XORLW       63
	BTFSS       STATUS+0, 2 
	GOTO        L_decode_rs23221
;UART.c,265 :: 		PrintOut(PrintHandler, "%5.0f\r",adcvalue);
	MOVLW       _PrintHandler+0
	MOVWF       FARG_PrintOut_prntoutfunc+0 
	MOVLW       hi_addr(_PrintHandler+0)
	MOVWF       FARG_PrintOut_prntoutfunc+1 
	MOVLW       FARG_PrintHandler_c+0
	MOVWF       FARG_PrintOut_prntoutfunc+2 
	MOVLW       hi_addr(FARG_PrintHandler_c+0)
	MOVWF       FARG_PrintOut_prntoutfunc+3 
	MOVLW       ?lstr_6_UART+0
	MOVWF       FARG_PrintOut_f+0 
	MOVLW       hi_addr(?lstr_6_UART+0)
	MOVWF       FARG_PrintOut_f+1 
	MOVLW       higher_addr(?lstr_6_UART+0)
	MOVWF       FARG_PrintOut_f+2 
	MOVF        _adcvalue+0, 0 
	MOVWF       FARG_PrintOut_prntoutfunc+7 
	MOVF        _adcvalue+1, 0 
	MOVWF       FARG_PrintOut_prntoutfunc+8 
	MOVF        _adcvalue+2, 0 
	MOVWF       FARG_PrintOut_prntoutfunc+9 
	MOVF        _adcvalue+3, 0 
	MOVWF       FARG_PrintOut_prntoutfunc+10 
	CALL        _PrintOut+0, 0
;UART.c,266 :: 		asm nop;
	NOP
;UART.c,267 :: 		}
	GOTO        L_decode_rs23222
L_decode_rs23221:
;UART.c,268 :: 		else if(getset=='>')       // SET
	MOVF        _getset+0, 0 
	XORLW       62
	BTFSS       STATUS+0, 2 
	GOTO        L_decode_rs23223
;UART.c,271 :: 		}
L_decode_rs23223:
L_decode_rs23222:
;UART.c,272 :: 		asm nop;
	NOP
;UART.c,273 :: 		break;
	GOTO        L_decode_rs23211
;UART.c,275 :: 		case SET:    // SET PORTB
L_decode_rs23224:
;UART.c,276 :: 		if(getset=='?') // get
	MOVF        _getset+0, 0 
	XORLW       63
	BTFSS       STATUS+0, 2 
	GOTO        L_decode_rs23225
;UART.c,278 :: 		cTemp = PORTB;    // grab PORTB
	MOVF        PORTB+0, 0 
	MOVWF       _cTemp+0 
;UART.c,279 :: 		iTemp = cTemp;    // promote to int
	MOVF        _cTemp+0, 0 
	MOVWF       _iTemp+0 
	MOVLW       0
	MOVWF       _iTemp+1 
;UART.c,280 :: 		PrintOut(PrintHandler, "%X\r",iTemp);
	MOVLW       _PrintHandler+0
	MOVWF       FARG_PrintOut_prntoutfunc+0 
	MOVLW       hi_addr(_PrintHandler+0)
	MOVWF       FARG_PrintOut_prntoutfunc+1 
	MOVLW       FARG_PrintHandler_c+0
	MOVWF       FARG_PrintOut_prntoutfunc+2 
	MOVLW       hi_addr(FARG_PrintHandler_c+0)
	MOVWF       FARG_PrintOut_prntoutfunc+3 
	MOVLW       ?lstr_7_UART+0
	MOVWF       FARG_PrintOut_f+0 
	MOVLW       hi_addr(?lstr_7_UART+0)
	MOVWF       FARG_PrintOut_f+1 
	MOVLW       higher_addr(?lstr_7_UART+0)
	MOVWF       FARG_PrintOut_f+2 
	MOVF        _iTemp+0, 0 
	MOVWF       FARG_PrintOut_prntoutfunc+7 
	MOVF        _iTemp+1, 0 
	MOVWF       FARG_PrintOut_prntoutfunc+8 
	CALL        _PrintOut+0, 0
;UART.c,281 :: 		asm nop;
	NOP
;UART.c,282 :: 		}
	GOTO        L_decode_rs23226
L_decode_rs23225:
;UART.c,283 :: 		else if(getset=='>')       // SET
	MOVF        _getset+0, 0 
	XORLW       62
	BTFSS       STATUS+0, 2 
	GOTO        L_decode_rs23227
;UART.c,285 :: 		iTemp = atoi(&rxBuf[RS_DATA]);     // get value
	MOVLW       _rxBuf+4
	MOVWF       FARG_atoi_s+0 
	MOVLW       hi_addr(_rxBuf+4)
	MOVWF       FARG_atoi_s+1 
	CALL        _atoi+0, 0
	MOVF        R0, 0 
	MOVWF       _iTemp+0 
	MOVF        R1, 0 
	MOVWF       _iTemp+1 
;UART.c,286 :: 		cTemp = iTemp & 0xFF;
	MOVLW       255
	ANDWF       R0, 0 
	MOVWF       R0 
	MOVF        R0, 0 
	MOVWF       _cTemp+0 
;UART.c,287 :: 		PORTB = cTemp;
	MOVF        R0, 0 
	MOVWF       PORTB+0 
;UART.c,288 :: 		asm nop;
	NOP
;UART.c,289 :: 		}
L_decode_rs23227:
L_decode_rs23226:
;UART.c,290 :: 		asm nop;
	NOP
;UART.c,291 :: 		break;
	GOTO        L_decode_rs23211
;UART.c,294 :: 		default:    // bad command or comms trashed!
L_decode_rs23228:
;UART.c,295 :: 		UART1_Write_Text("FAIL\r");
	MOVLW       ?lstr8_UART+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr8_UART+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;UART.c,296 :: 		asm nop;
	NOP
;UART.c,297 :: 		break;
	GOTO        L_decode_rs23211
;UART.c,298 :: 		} // end switch
L_decode_rs23210:
	MOVF        _cmd+0, 0 
	XORLW       1
	BTFSC       STATUS+0, 2 
	GOTO        L_decode_rs23212
	MOVF        _cmd+0, 0 
	XORLW       2
	BTFSC       STATUS+0, 2 
	GOTO        L_decode_rs23216
	MOVF        _cmd+0, 0 
	XORLW       3
	BTFSC       STATUS+0, 2 
	GOTO        L_decode_rs23220
	MOVF        _cmd+0, 0 
	XORLW       4
	BTFSC       STATUS+0, 2 
	GOTO        L_decode_rs23224
	GOTO        L_decode_rs23228
L_decode_rs23211:
;UART.c,299 :: 		clear_rx();    // always flush buffer
	CALL        _clear_rx+0, 0
;UART.c,300 :: 		}
L_end_decode_rs232:
	RETURN      0
; end of _decode_rs232
